/*
 * WSO2 API Manager - Publisher API
 * This specifies a **RESTful API** for WSO2 **API Manager** - Publisher.  Please see [full swagger definition](https://raw.githubusercontent.com/wso2/carbon-apimgt/v6.0.4/components/apimgt/org.wso2.carbon.apimgt.rest.api.publisher/src/main/resources/publisher-api.yaml) of the API which is written using [swagger 2.0](http://swagger.io/) specification. 
 *
 * OpenAPI spec version: v1.1
 * Contact: architecture@wso2.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package org.wso2.am.integration.clients.publisher.api.v1.dto;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * APIOperationsDTO
 */

public class APIOperationsDTO {
  @SerializedName("id")
  private String id = null;

  @SerializedName("target")
  private String target = null;

  @SerializedName("verb")
  private String verb = null;

  @SerializedName("authType")
  private String authType = "Any";

  @SerializedName("throttlingPolicy")
  private String throttlingPolicy = null;

  @SerializedName("scopes")
  private List<String> scopes = null;

  @SerializedName("usedProductIds")
  private List<String> usedProductIds = null;

  @SerializedName("amznResourceName")
  private String amznResourceName = null;

  @SerializedName("amznResourceTimeout")
  private Integer amznResourceTimeout = null;

  public APIOperationsDTO id(String id) {
    this.id = id;
    return this;
  }

   /**
   * Get id
   * @return id
  **/
  @ApiModelProperty(example = "postapiresource", value = "")
  public String getId() {
    return id;
  }

  public void setId(String id) {
    this.id = id;
  }

  public APIOperationsDTO target(String target) {
    this.target = target;
    return this;
  }

   /**
   * Get target
   * @return target
  **/
  @ApiModelProperty(value = "")
  public String getTarget() {
    return target;
  }

  public void setTarget(String target) {
    this.target = target;
  }

  public APIOperationsDTO verb(String verb) {
    this.verb = verb;
    return this;
  }

   /**
   * Get verb
   * @return verb
  **/
  @ApiModelProperty(value = "")
  public String getVerb() {
    return verb;
  }

  public void setVerb(String verb) {
    this.verb = verb;
  }

  public APIOperationsDTO authType(String authType) {
    this.authType = authType;
    return this;
  }

   /**
   * Get authType
   * @return authType
  **/
  @ApiModelProperty(value = "")
  public String getAuthType() {
    return authType;
  }

  public void setAuthType(String authType) {
    this.authType = authType;
  }

  public APIOperationsDTO throttlingPolicy(String throttlingPolicy) {
    this.throttlingPolicy = throttlingPolicy;
    return this;
  }

   /**
   * Get throttlingPolicy
   * @return throttlingPolicy
  **/
  @ApiModelProperty(example = "Unlimited", value = "")
  public String getThrottlingPolicy() {
    return throttlingPolicy;
  }

  public void setThrottlingPolicy(String throttlingPolicy) {
    this.throttlingPolicy = throttlingPolicy;
  }

  public APIOperationsDTO scopes(List<String> scopes) {
    this.scopes = scopes;
    return this;
  }

  public APIOperationsDTO addScopesItem(String scopesItem) {
    if (this.scopes == null) {
      this.scopes = new ArrayList<>();
    }
    this.scopes.add(scopesItem);
    return this;
  }

   /**
   * Get scopes
   * @return scopes
  **/
  @ApiModelProperty(value = "")
  public List<String> getScopes() {
    return scopes;
  }

  public void setScopes(List<String> scopes) {
    this.scopes = scopes;
  }

  public APIOperationsDTO usedProductIds(List<String> usedProductIds) {
    this.usedProductIds = usedProductIds;
    return this;
  }

  public APIOperationsDTO addUsedProductIdsItem(String usedProductIdsItem) {
    if (this.usedProductIds == null) {
      this.usedProductIds = new ArrayList<>();
    }
    this.usedProductIds.add(usedProductIdsItem);
    return this;
  }

   /**
   * Get usedProductIds
   * @return usedProductIds
  **/
  @ApiModelProperty(value = "")
  public List<String> getUsedProductIds() {
    return usedProductIds;
  }

  public void setUsedProductIds(List<String> usedProductIds) {
    this.usedProductIds = usedProductIds;
  }

  public APIOperationsDTO amznResourceName(String amznResourceName) {
    this.amznResourceName = amznResourceName;
    return this;
  }

   /**
   * Get amznResourceName
   * @return amznResourceName
  **/
  @ApiModelProperty(value = "")
  public String getAmznResourceName() {
    return amznResourceName;
  }

  public void setAmznResourceName(String amznResourceName) {
    this.amznResourceName = amznResourceName;
  }

  public APIOperationsDTO amznResourceTimeout(Integer amznResourceTimeout) {
    this.amznResourceTimeout = amznResourceTimeout;
    return this;
  }

   /**
   * Get amznResourceTimeout
   * @return amznResourceTimeout
  **/
  @ApiModelProperty(value = "")
  public Integer getAmznResourceTimeout() {
    return amznResourceTimeout;
  }

  public void setAmznResourceTimeout(Integer amznResourceTimeout) {
    this.amznResourceTimeout = amznResourceTimeout;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    APIOperationsDTO apIOperations = (APIOperationsDTO) o;
    return Objects.equals(this.id, apIOperations.id) &&
        Objects.equals(this.target, apIOperations.target) &&
        Objects.equals(this.verb, apIOperations.verb) &&
        Objects.equals(this.authType, apIOperations.authType) &&
        Objects.equals(this.throttlingPolicy, apIOperations.throttlingPolicy) &&
        Objects.equals(this.scopes, apIOperations.scopes) &&
        Objects.equals(this.usedProductIds, apIOperations.usedProductIds) &&
        Objects.equals(this.amznResourceName, apIOperations.amznResourceName) &&
        Objects.equals(this.amznResourceTimeout, apIOperations.amznResourceTimeout);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, target, verb, authType, throttlingPolicy, scopes, usedProductIds, amznResourceName, amznResourceTimeout);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class APIOperationsDTO {\n");
    
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    target: ").append(toIndentedString(target)).append("\n");
    sb.append("    verb: ").append(toIndentedString(verb)).append("\n");
    sb.append("    authType: ").append(toIndentedString(authType)).append("\n");
    sb.append("    throttlingPolicy: ").append(toIndentedString(throttlingPolicy)).append("\n");
    sb.append("    scopes: ").append(toIndentedString(scopes)).append("\n");
    sb.append("    usedProductIds: ").append(toIndentedString(usedProductIds)).append("\n");
    sb.append("    amznResourceName: ").append(toIndentedString(amznResourceName)).append("\n");
    sb.append("    amznResourceTimeout: ").append(toIndentedString(amznResourceTimeout)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

