/*
 * WSO2 API Manager - Publisher API
 * This specifies a **RESTful API** for WSO2 **API Manager** - Publisher.  Please see [full swagger definition](https://raw.githubusercontent.com/wso2/carbon-apimgt/v6.0.4/components/apimgt/org.wso2.carbon.apimgt.rest.api.publisher/src/main/resources/publisher-api.yaml) of the API which is written using [swagger 2.0](http://swagger.io/) specification. 
 *
 * OpenAPI spec version: v1.1
 * Contact: architecture@wso2.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package org.wso2.am.integration.clients.publisher.api.v1.dto;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import org.wso2.am.integration.clients.publisher.api.v1.dto.SharedScopeUsedAPIInfoDTO;

/**
 * SharedScopeUsageDTO
 */

public class SharedScopeUsageDTO {
  @SerializedName("id")
  private String id = null;

  @SerializedName("name")
  private String name = null;

  @SerializedName("usedApiList")
  private List<SharedScopeUsedAPIInfoDTO> usedApiList = null;

  public SharedScopeUsageDTO id(String id) {
    this.id = id;
    return this;
  }

   /**
   * UUID of the Scope. Valid only for shared scopes. 
   * @return id
  **/
  @ApiModelProperty(example = "01234567-0123-0123-0123-012345678901", required = true, value = "UUID of the Scope. Valid only for shared scopes. ")
  public String getId() {
    return id;
  }

  public void setId(String id) {
    this.id = id;
  }

  public SharedScopeUsageDTO name(String name) {
    this.name = name;
    return this;
  }

   /**
   * name of Scope 
   * @return name
  **/
  @ApiModelProperty(example = "apim:api_view", required = true, value = "name of Scope ")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public SharedScopeUsageDTO usedApiList(List<SharedScopeUsedAPIInfoDTO> usedApiList) {
    this.usedApiList = usedApiList;
    return this;
  }

  public SharedScopeUsageDTO addUsedApiListItem(SharedScopeUsedAPIInfoDTO usedApiListItem) {
    if (this.usedApiList == null) {
      this.usedApiList = new ArrayList<>();
    }
    this.usedApiList.add(usedApiListItem);
    return this;
  }

   /**
   * API list which have used the shared scope 
   * @return usedApiList
  **/
  @ApiModelProperty(value = "API list which have used the shared scope ")
  public List<SharedScopeUsedAPIInfoDTO> getUsedApiList() {
    return usedApiList;
  }

  public void setUsedApiList(List<SharedScopeUsedAPIInfoDTO> usedApiList) {
    this.usedApiList = usedApiList;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SharedScopeUsageDTO sharedScopeUsage = (SharedScopeUsageDTO) o;
    return Objects.equals(this.id, sharedScopeUsage.id) &&
        Objects.equals(this.name, sharedScopeUsage.name) &&
        Objects.equals(this.usedApiList, sharedScopeUsage.usedApiList);
  }

  @Override
  public int hashCode() {
    return Objects.hash(id, name, usedApiList);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class SharedScopeUsageDTO {\n");
    
    sb.append("    id: ").append(toIndentedString(id)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    usedApiList: ").append(toIndentedString(usedApiList)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

